- content_for :title
  = 'Positions'

- if @positions.any?
  - @positions.each do |user, positions|
    ruby:
      last_position = positions.last
      positions = positions.map { |position| [position.latitude.to_f, position.longitude.to_f] }
    = map(center: { latlng: [last_position.latitude, last_position.longitude], zoom: 18 })
    javascript:
      var marker = L.marker([#{last_position.latitude}, #{last_position.longitude}]).addTo(map);
      var positions = #{positions.to_json.html_safe};
      var polyline = L.polyline(positions, { color: 'red', className: '#{user_color_class(user)}', opacity: 0.75, weight: 2 }).addTo(map);
      // map.fitBounds(polyline.getBounds());
      // positions.forEach(function (position) {
      //   L.circle(position, { radius: 0, color: 'red', weight: 3 }).addTo(map);
      // });
- else
  ruby:
  = map(center: { latlng: [52.518611111111, 13.408333333333] }, zoom: 13)

ruby:
  since = DateTime.parse(params[:since])
  untill = DateTime.parse(params[:until])
  range = untill - since

.date-slider-container
  #date-slider
javascript:
  function zeroPad(value, pad) {
    var padString = '';
    for (var i = 0; i < pad; i++) {
      padString += '0';
    }
    return (padString + value).slice(-1 * pad);
  }

  function formatDate(value) {
    date = new Date(value * 1000);
    year = date.getFullYear();
    month = zeroPad(date.getMonth() + 1, 2);
    day = zeroPad(date.getDate(), 2);
    hour = zeroPad(date.getHours(), 2);
    minute = zeroPad(date.getMinutes(), 2);
    return year + '-' + month + '-' + day + ' ' + hour + ':' + minute;
  }

  function urlParams() {
    var match,
        pl = /\+/g,
        search = /([^&=]+)=?([^&]*)/g,
        decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
        query = window.location.search.substring(1),
        urlParams = {};
    while (match = search.exec(query)) {
      urlParams[decode(match[1])] = decode(match[2]);
    }
    return urlParams;
  }

  function paramString(params) {
    var paramString = '';
    Object.keys(params).forEach(function (key) {
      if (paramString == '') {
        paramString += '?'
      } else {
        paramString += '&'
      }
      paramString += key + '=' + encodeURIComponent(params[key]).replace('%20', '+');
    });
    return paramString;
  }

  var slider = document.getElementById('date-slider');
  noUiSlider.create(slider, {
    connect: true,
    range: {
      min: #{[(since - (0.2 * range)).to_i].min},
      max: #{[(untill + (0.2 * range)).to_i].max}
    },
    // Steps of 1 minute
    step: 1 * 60,
    // Two more timestamps indicate the handle starting positions.
    start: [#{since.to_i}, #{untill.to_i}],
    // No decimals
    format: {
      to: formatDate,
      from: Number
    }
  });
  slider.noUiSlider.on('change', function (range) {
    var params = urlParams();
    console.log(range);
    params.since = range[0] + ':00 UTC+0200';
    params.until = range[1] + ':00 UTC+0200';
    console.log('/positions' + paramString(params));
    Turbolinks.visit('/positions' + paramString(params));
    document.querySelectorAll('.noUi-handle').forEach(function (handle) {
      handle.classList.add('noUi-active');
    });
  });
  document.querySelectorAll('.noUi-handle').forEach(function (handle) {
    handle.classList.add('noUi-active');
  });

- if @users&.any?
  - content_for :additional_sidebar
    li
      .divider
    li
      a.subheader
        | Users
    - @all_users.each do |user|
      li.position-user
        label
          ruby:
            checked = {}
            checked = { checked: 'checked' } if @users.include?(user)
          input.filled-in data-user-id="#{user.id}" class="#{user_color_class(user)}" type='checkbox' *checked
          span
            = user.name
    li
      a href="#{positions_path(since: params[:since], until: params[:until], users: params[:users], format: :csv)}"
        i.material-icons.left cloud_download
        | CSV
    javascript:
      document.querySelectorAll('li.position-user input').forEach(function (checkbox) {
        checkbox.addEventListener('click', function () {
          if (this.checked) {
            var newUrl = window.location + '&users[]=' + this.dataset.userId;
          } else {
            var newUrl = decodeURIComponent(window.location + '').replace('&users[]=' + this.dataset.userId, '')
          }
          console.log(newUrl);
          Turbolinks.visit(newUrl);
        });
      });
